# -*- coding: utf-8 -*-

"""Main module."""
import random

import discord
from discord.ext import commands

import os
import requests

class Mybot(commands.Cog):
    def __init__(self, bot):
        self.bot = bot

    @commands.command()
    async def join(self, ctx):
        channel = [x for x in self.bot.get_all_channels() if x.name == "Général"][0]
        await channel.connect()

    @commands.command()
    async def disconnect(self, ctx):
        await ctx.guild.voice_client.disconnect()

    @commands.command()
    async def benjamin(self, ctx):
        source = discord.PCMVolumeTransformer(discord.FFmpegPCMAudio("/tmp/Benjamin_Prejent.mp3"))
        ctx.voice_client.play(source, after=lambda e: print('Player error: %s' % e) if e else None)
        await ctx.send('Now playing')

    @commands.command(help='check if bot always online')
    async def ping(self, message):
        await message.channel.send('pong')

    @commands.command(help="optionnal args : [livre] [character]")
    async def kaamelott(self, ctx, *args):
        response = None
        if not args:
            url = 'https://kaamelott.chaudie.re/api/random'
        else:
            args = list(args)
            if args[0].isdigit():
                livre = int(args[0])
                args.pop(0)
            elif args[-1].isdigit():
                livre = int(args[-1])
                args.pop(-1)
            else:
                livre = None
            if args:
                perso = ' '.join(args)
            if perso and livre:
                url = 'https://kaamelott.chaudie.re/api/random/livre/%s/personnage/%s' % (livre,perso)
            elif perso:
                url = 'https://kaamelott.chaudie.re/api/random/personnage/%s' % perso
            else:
                url = 'https://kaamelott.chaudie.re/api/random/livre/%s' % livre
        try:
            citation = requests.get(url).json()['citation']
            response = "%s :\n```\n%s\n```" % (citation['infos']['personnage'], citation['citation'])
        except:
            response = "Unknow error, try: !kaamelott [livre] [character]"
        await ctx.send(response)


def main():
    token = "NjI3MTM3NDY1MDA5ODMxOTQ2.XY4Raw.pw8sAen3bNR5aYsoTChQOudM0L8"
    bot = commands.Bot(command_prefix='!')

    @bot.event
    async def on_message(message):
        print(message.content)
        if message.author == bot.user:
            return
        else:
            if bot.user in message.mentions \
                    and len(message.mentions) < 3 \
                    and len(message.content.splitlines()) == 1:
                path = '/tmp/%s.log' % message.channel
                with open(path, 'r') as f :
                    lines = f.read().splitlines()
                if not message.content in lines:
                    with open(path, 'a') as f :
                        f.write(message.content + '\n')
                response = random.choice(lines).replace(str(bot.user.id), str(message.author.id))
                await message.channel.send(response)
        await bot.process_commands(message)
    
    @bot.event
    async def on_voice_state_update(member,before,after):
        if "BFlow" in member.name:
            if before.channel is None and after.channel:
                for channel in bot.get_all_channels():
                    if channel.name == "général":
                        current_chan = channel
                ctx = bot.get_context(current_chan.last_message)
                benjamin = bot.get_command('benjamin')
                await benjamin.invoke(ctx)

    bot.add_cog(Mybot(bot))
    bot.run(token)


if __name__ == "__main__":
    main()

